#include <IRremote.h>

long ir_rec;

IRrecv irrecv(A0);
decode_results results;

unsigned char start01[] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};

unsigned char front[] = {0x00,0x00,0x00,0x00,0x00,0x24,0x12,0x09,0x12,0x24,0x00,0x00,0x00,0x00,0x00,0x00};

unsigned char back[] = {0x00,0x00,0x00,0x00,0x00,0x24,0x48,0x90,0x48,0x24,0x00,0x00,0x00,0x00,0x00,0x00};

unsigned char left[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x44,0x28,0x10,0x44,0x28,0x10,0x44,0x28,0x10,0x00};

unsigned char right[] = {0x00,0x10,0x28,0x44,0x10,0x28,0x44,0x10,0x28,0x44,0x00,0x00,0x00,0x00,0x00,0x00};

unsigned char STOP01[] = {0x2E,0x2A,0x3A,0x00,0x02,0x3E,0x02,0x00,0x3E,0x22,0x3E,0x00,0x3E,0x0A,0x0E,0x00};

unsigned char clear[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};

#define IIC_SCL  A5

#define IIC_SDA  A4

unsigned char data_line = 0;

unsigned char delay_count = 0;

void IIC_start()
{
  digitalWrite(IIC_SCL,LOW);
  delayMicroseconds(3);
  digitalWrite(IIC_SDA,HIGH);
  delayMicroseconds(3);
  digitalWrite(IIC_SCL,HIGH);
  delayMicroseconds(3);
  digitalWrite(IIC_SDA,LOW);
  delayMicroseconds(3);}

void IIC_send(unsigned char send_data)
{
  for(char i = 0;i < 8;i++)
  {
      digitalWrite(IIC_SCL,LOW);
      delayMicroseconds(3);
      if(send_data & 0x01)
      {
        digitalWrite(IIC_SDA,HIGH);
      }
      else
      {
        digitalWrite(IIC_SDA,LOW);
      }
      delayMicroseconds(3);
      digitalWrite(IIC_SCL,HIGH);
      delayMicroseconds(3);
      send_data = send_data >> 1;
  }
}

void IIC_end()
{
  digitalWrite(IIC_SCL,LOW);
  delayMicroseconds(3);
  digitalWrite(IIC_SDA,LOW);
  delayMicroseconds(3);
  digitalWrite(IIC_SCL,HIGH);
  delayMicroseconds(3);
  digitalWrite(IIC_SDA,HIGH);
  delayMicroseconds(3);}

volatile int pulsewidth;
void procedure(int myangle) {
  for (int i = 0; i <= 50; i = i + (1)) {
    pulsewidth = myangle * 11 + 500;
    digitalWrite(9,HIGH);
    delayMicroseconds(pulsewidth);
    digitalWrite(9,LOW);
    delay((20 - pulsewidth / 1000));
  }
}

void setup(){
  Serial.begin(9600);
  irrecv.enableIRIn();
  pinMode(12, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(13, OUTPUT);
  pinMode(11, OUTPUT);
    pinMode(IIC_SCL,OUTPUT);
  pinMode(IIC_SDA,OUTPUT);
  digitalWrite(IIC_SCL,LOW);
  digitalWrite(IIC_SDA,LOW);
  IIC_start();
    IIC_send(0x40);
    IIC_end();
    IIC_start();
    IIC_send(0xc0);
  pulsewidth = 0;
  pinMode(9, OUTPUT);
  IIC_start();
      IIC_send(0xc0);
      for(char i = 0;i < 16;i++)
      {
         IIC_send(clear[i]);
      }
      if(++delay_count >= 10)
      {
        delay_count = 0;
        data_line++;
        if(data_line >= 4)
        {
          data_line = 0;
        }
      }
      IIC_end();
      IIC_start();
      IIC_send(0x8A);
      IIC_end();
  IIC_start();
      IIC_send(0xc0);
      for(char i = 0;i < 16;i++)
      {
         IIC_send(start01[i]);
      }
      if(++delay_count >= 10)
      {
        delay_count = 0;
        data_line++;
        if(data_line >= 4)
        {
          data_line = 0;
        }
      }
      IIC_end();
      IIC_start();
      IIC_send(0x8A);
      IIC_end();
  procedure(90);
}

void loop(){
  if (irrecv.decode(&results)) {
    ir_rec=results.value;
    String type="UNKNOWN";
    String typelist[14]={"UNKNOWN", "NEC", "SONY", "RC5", "RC6", "DISH", "SHARP", "PANASONIC", "JVC", "SANYO", "MITSUBISHI", "SAMSUNG", "LG", "WHYNTER"};
    if(results.decode_type>=1&&results.decode_type<=13){
      type=typelist[results.decode_type];
    }
    Serial.print("IR TYPE:"+type+"  ");
    Serial.println(ir_rec,HEX);
    irrecv.resume();
  } else {
  }
  if (ir_rec == 0xFF629D) {
    digitalWrite(12,LOW);
    analogWrite(3,200);
    digitalWrite(13,LOW);
    analogWrite(11,200);
    IIC_start();
        IIC_send(0xc0);
        for(char i = 0;i < 16;i++)
        {
           IIC_send(front[i]);
        }
        if(++delay_count >= 10)
        {
          delay_count = 0;
          data_line++;
          if(data_line >= 4)
          {
            data_line = 0;
          }
        }
        IIC_end();
        IIC_start();
        IIC_send(0x8A);
        IIC_end();

  }
  if (ir_rec == 0xFFA857) {
    digitalWrite(12,HIGH);
    analogWrite(3,200);
    digitalWrite(13,HIGH);
    analogWrite(11,200);
    IIC_start();
        IIC_send(0xc0);
        for(char i = 0;i < 16;i++)
        {
           IIC_send(back[i]);
        }
        if(++delay_count >= 10)
        {
          delay_count = 0;
          data_line++;
          if(data_line >= 4)
          {
            data_line = 0;
          }
        }
        IIC_end();
        IIC_start();
        IIC_send(0x8A);
        IIC_end();

  }
  if (ir_rec == 0xFF22DD) {
    digitalWrite(12,LOW);
    analogWrite(3,255);
    digitalWrite(13,LOW);
    analogWrite(11,180);
    IIC_start();
        IIC_send(0xc0);
        for(char i = 0;i < 16;i++)
        {
           IIC_send(left[i]);
        }
        if(++delay_count >= 10)
        {
          delay_count = 0;
          data_line++;
          if(data_line >= 4)
          {
            data_line = 0;
          }
        }
        IIC_end();
        IIC_start();
        IIC_send(0x8A);
        IIC_end();

  }
  if (ir_rec == 0xFFC23D) {
    digitalWrite(12,LOW);
    analogWrite(3,180);
    digitalWrite(13,LOW);
    analogWrite(11,255);
    IIC_start();
        IIC_send(0xc0);
        for(char i = 0;i < 16;i++)
        {
           IIC_send(right[i]);
        }
        if(++delay_count >= 10)
        {
          delay_count = 0;
          data_line++;
          if(data_line >= 4)
          {
            data_line = 0;
          }
        }
        IIC_end();
        IIC_start();
        IIC_send(0x8A);
        IIC_end();

  }
  if (ir_rec == 0xFF02FD) {
    digitalWrite(12,LOW);
    analogWrite(3,0);
    digitalWrite(13,LOW);
    analogWrite(11,0);
    IIC_start();
        IIC_send(0xc0);
        for(char i = 0;i < 16;i++)
        {
           IIC_send(STOP01[i]);
        }
        if(++delay_count >= 10)
        {
          delay_count = 0;
          data_line++;
          if(data_line >= 4)
          {
            data_line = 0;
          }
        }
        IIC_end();
        IIC_start();
        IIC_send(0x8A);
        IIC_end();

  }
  if (ir_rec == 0xFF30CF) {
    digitalWrite(12,LOW);
    analogWrite(3,200);
    digitalWrite(13,HIGH);
    analogWrite(11,200);
    IIC_start();
        IIC_send(0xc0);
        for(char i = 0;i < 16;i++)
        {
           IIC_send(left[i]);
        }
        if(++delay_count >= 10)
        {
          delay_count = 0;
          data_line++;
          if(data_line >= 4)
          {
            data_line = 0;
          }
        }
        IIC_end();
        IIC_start();
        IIC_send(0x8A);
        IIC_end();

  }
  if (ir_rec == 0xFF7A85) {
    digitalWrite(12,HIGH);
    analogWrite(3,200);
    digitalWrite(13,LOW);
    analogWrite(11,200);
    IIC_start();
        IIC_send(0xc0);
        for(char i = 0;i < 16;i++)
        {
           IIC_send(right[i]);
        }
        if(++delay_count >= 10)
        {
          delay_count = 0;
          data_line++;
          if(data_line >= 4)
          {
            data_line = 0;
          }
        }
        IIC_end();
        IIC_start();
        IIC_send(0x8A);
        IIC_end();

  }

}
